from cpl_core.configuration import ConfigurationABC
from cpl_core.environment import ApplicationEnvironmentABC
from cpl_core.mailing import EMailClientABC, EMailClientSettings
from cpl_query.extension import List
from cpl_translation import TranslatePipe
from flask import request
from flask_cors import cross_origin

from bot_api.api import Api
from bot_api.logging.api_logger import ApiLogger
from bot_api.model.token_dto import TokenDTO
from bot_api.route.route import Route
from bot_data.model.auth_user import AuthUser


class AuthController:

    def __init__(
            self,
            config: ConfigurationABC,
            env: ApplicationEnvironmentABC,
            logger: ApiLogger,
            t: TranslatePipe,
            api: Api,
            mail_settings: EMailClientSettings,
            mailer: EMailClientABC
    ):
        self._config = config
        self._env = env
        self._logger = logger
        self._t = t
        self._api = api
        self._mail_settings = mail_settings
        self._mailer = mailer

    @Route.route('/api/auth/get-all-users')
    async def get_all_users(self) -> List[AuthUser]:
        pass

    @Route.route('/api/auth/get-filtered-users', methods=['POST'])
    async def get_filtered_users(self) -> List[AuthUser]:
        pass

    @Route.route('/api/auth/login', methods=['POST'])
    async def login(self) -> dict:
        self._logger.warn(__name__, f'Received {request.json}')
        return TokenDTO().to_dict()
