from datetime import datetime
from typing import Optional
from cpl_core.database import TableABC

from bot_data.model.auth_role_enum import AuthRoleEnum
from bot_data.model.server import Server


class AuthUser(TableABC):

    def __init__(
            self,
            first_name: str,
            last_name: str,
            email: str,
            password: str,
            refresh_token: str,
            confirmation_id: str,
            forgot_password_id: str,
            refresh_token_expire_time: datetime,
            auth_role: AuthRoleEnum,
            created_at: datetime = None,
            modified_at: datetime = None,
            id=0
    ):
        self._auth_user_id = id
        self._first_name = first_name
        self._last_name = last_name
        self._email = email
        self._password = password
        self._refresh_token = refresh_token
        self._confirmation_id = confirmation_id
        self._forgot_password_id = forgot_password_id
        self._refresh_token_expire_time = refresh_token_expire_time

        self._auth_role_id = auth_role.value

        TableABC.__init__(self)
        self._created_at = created_at if created_at is not None else self._created_at
        self._modified_at = modified_at if modified_at is not None else self._modified_at

    @staticmethod
    def get_select_all_string() -> str:
        return str(f"""
            SELECT * FROM `AuthUsers`;
        """)

    @staticmethod
    def get_select_by_id_string(id: int) -> str:
        return str(f"""
            SELECT * FROM `AuthUsers`
            WHERE `Id` = {id};
        """)

    @property
    def insert_string(self) -> str:
        return str(f"""
            INSERT INTO `AuthUsers` (
                `Id`,
                `FirstName`,
                `LastName`,
                `EMail`,
                `Password`,
                `RefreshToken`,
                `ConfirmationId`,
                `ForgotPasswordId`,
                `RefreshTokenExpiryTime`,
                `AuthRole`,
                `CreatedOn`,
                `LastModifiedOn`
                ) VALUES (
                    {self._auth_user_id}, 
                    {self._first_name}, 
                    {self._last_name}, 
                    {self._email}, 
                    {self._password}, 
                    {self._refresh_token}, 
                    {self._confirmation_id}, 
                    {self._forgot_password_id}, 
                    {self._refresh_token_expire_time}, 
                    {self._auth_role_id}
                    {self._created_at}, 
                    {self._modified_at}
                )
        """)

    @property
    def udpate_string(self) -> str:
        return str(f"""
            UPDATE `AuthUsers`
            SET `FirstName` = '{self._first_name}', 
            `LastName` = '{self._last_name}', 
            `EMail` = '{self._email}', 
            `Password` = '{self._password}', 
            `RefreshToken` = '{self._refresh_token}', 
            `ConfirmationId` = '{self._confirmation_id}', 
            `ForgotPasswordId` = '{self._forgot_password_id}',
            `RefreshTokenExpiryTime` = '{self._refresh_token_expire_time}',
            `AutoRole` = {self._auth_role_id},
            `LastModifiedAt` = '{self._modified_at}'
            WHERE `AuthUsers`.`Id` = {self._auth_user_id};
        """)

    @property
    def delete_string(self) -> str:
        return str(f"""
            DELETE FROM `AuthUsers`
            WHERE `Id` = {self._auth_user_id};
        """)
